(* $Id: c_table.mli,v 1.4 2008/04/19 14:07:08 deraugla Exp $ *)

open Rtdecl;

(*** Reported events *)

type table_event = [ ];

(*** Table widget builder *)

type table_args = list (list table_data)
and table_data = [ TD of list table_data_attr and widget_desc ]
and table_data_attr = [ Colspan of int ];

type table_event_handler = widget -> table_event -> unit;

value table_desc :
  list attribute -> table_args -> table_event_handler -> widget_desc;

value table_add_row : widget -> list table_data -> unit;
   (* Add a row at table bottom with the list of widget_desc. Need a call
      to [rt_adjust_widget] on the top window it belongs to to terminate
      the job. *)
value table_remove_nth_row : widget -> int -> unit;
   (* Remove the n-th row of the table. Need a call to [rt_adjust_widget]
      on the top window it belongs to to terminate the job. *)
