(* $Id: util.mli,v 1.7 2008/03/20 18:35:12 deraugla Exp $ *)

open Rtdecl;
open Xlib;

type glob_struct = { xgcv : xGCValues; xev : xEvent; fds : fd_set };

type attribute_values =
  { backg_att : option paint;
    band_att : option int;
    bd_backg_att : option paint;
    bold_att : option int;
    border_att : option int;
    font_att : array font;
    foreg_att : option paint;
    height_att : option int;
    inter_att : option int;
    left_justif : bool;
    name_att : option string;
    width_att : option int }
;

value dynamo_global_info :
  string -> ref (option 'a) -> ('a -> global_info * global_info -> 'a);
value dynamo_local_info :
  string -> ref (option 'a) -> ('a -> local_info * local_info -> 'a);
value dynamo_args_info :
  string -> ref (option 'a) -> ('a -> args_info * args_info -> 'a);
value no_info : 'a -> string;
value no_user_info : user_info;
value no_args_info : args_info;
value mallocated_var : (unit -> 'a) -> ref (option 'a) -> 'b -> 'a;
value gstr : unit -> glob_struct;
value remove_ginfo : xdata -> string -> unit;
value ginfo : xdata -> string -> global_info;
value add_ginfo : xdata -> string -> ('a -> global_info) -> 'a -> 'a;
value remove_widget : option string -> drawable -> widget -> unit;
value create_widget :
  xdata -> window -> bool -> int -> int -> size_hints -> widget_desc ->
    local_info -> list widget -> widget;
value add_widget : option string -> window -> widget -> widget;
value destroy_widget : widget -> unit;
value create_window :
  xdata -> window -> bool -> int -> int -> size_hints -> attribute_values ->
    int -> window;
value set_delete_callback : widget -> delete_callback -> unit;
value set_wm_and_class_hints : widget -> unit;
value set_std_prop :
  widget -> string -> string -> int -> int -> size_hints -> int -> unit;
value make_array : int -> (int -> 'a) -> array 'a;
value lnot : int -> int;
value item_modified : int -> 'a -> modified 'a;
value attribute_values : list attribute -> attribute_values;
value opt_val : 'a -> option 'a -> 'a;
value nround : int -> int -> int;
value hsv_of_rgb : (int * int * int) -> (int * int * int);
value rgb_of_hsv : (int * int * int) -> (int * int * int);
value get_default : display -> string -> string -> string;
value keysym_int_of_xevent : xEvent -> int;
value map_popup_widget : widget -> int -> int -> int -> unit;
